{*******************************************************}
{                                                       }
{           Handling Reloader for GTA IV & EfLC         }
{             Created By GooD-NTS (C) 2013              }
{                                                       }
{                  http://openiv.com/                   }
{                                                       }
{                     Version 1.2                       }
{                                                       }
{*******************************************************}

library HandlingReloader;

uses
  Windows,
  SysUtils;

function GetExeFileVersion( AFileName: String ): String;
var
  dwSize, dwTemp: DWORD;
  abInfo: Array of byte;
  Pint: ^VS_FIXEDFILEINFO;
begin
  dwSize:= GetFileVersionInfoSize(pchar(AFileName),dwTemp);
  if dwSize <> 0 then
  begin
    SetLength(abInfo,dwSize);
    GetFileVersionInfo(pchar(AFileName),0,dwSize,@abInfo[0]);
    if VerQueryValue(@abInfo[0],'\',Pointer(pint), dwTemp) then
    begin
      Result := IntToStr( HiWord(pint^.dwFileVersionMS) );
      Result := Result + IntToStr( LoWord(pint^.dwFileVersionMS) );
      Result := Result + IntToStr( HiWord(pint^.dwFileVersionLS) );
      Result := Result + IntToStr( LoWord(pint^.dwFileVersionLS) );
    end;
  end;
end;

function KeyPressed(const Key : SmallInt) : Boolean;
begin
  Result := Hi(GetKeyState(Key)) = $FF;
end;

var
  readHandling : procedure(); stdcall;

procedure MainLoop();
begin
  while True do
  begin
    Sleep(100);
    if KeyPressed(VK_F8) then
    begin
      try
        if @readHandling <> nil then
        begin
          readHandling();
          Beep();
        end;
      except
      end;
      Sleep(2000);
    end;
  end;
end;

var
  idThread : Cardinal;

begin
  // GTAIV 1004: text:00BC4D60
  // GTAIV 1040: text:00BC2E50
  // GTAIV 1070: text:00971FC0

  // EfLC  1120: text:008DC120

  if LowerCase(ExtractFileName(GetModuleName(GetModuleHandleA(nil)))) = 'gtaiv.exe' then
  begin
    if GetExeFileVersion(GetModuleName(GetModuleHandleA(nil))) = '1070' then
      @readHandling := Ptr($00971FC0 - $400000 + GetModuleHandleA(nil))
    else
    if GetExeFileVersion(GetModuleName(GetModuleHandleA(nil))) = '1040' then
      @readHandling := Ptr($00BC2E50 - $400000 + GetModuleHandleA(nil))
    else
    if GetExeFileVersion(GetModuleName(GetModuleHandleA(nil))) = '1004' then
      @readHandling := Ptr($00BC4D60 - $400000 + GetModuleHandleA(nil))
    else
      @readHandling := nil;
  end
  else
  if LowerCase(ExtractFileName(GetModuleName(GetModuleHandleA(nil)))) = 'eflc.exe' then
    @readHandling := Ptr($008DC120 - $400000 + GetModuleHandleA(nil))
  else
    @readHandling := nil;

  if @readHandling <> nil then
    CreateThread(nil, 0, @MainLoop, nil, 0, idThread);
end.

